osp_detect() {
  case $1 in
    *.conf) SPACES=$(sed -n "/^output_session_processing {/,/^}/ {/^ *music {/p}" $1 | sed -r "s/( *).*/\1/")
            EFFECTS=$(sed -n "/^output_session_processing {/,/^}/ {/^$SPACES\music {/,/^$SPACES}/p}" $1 | grep -E "^$SPACES +[A-Za-z]+" | sed -r "s/( *.*) .*/\1/g")
            for EFFECT in ${EFFECTS}; do
              SPACES=$(sed -n "/^effects {/,/^}/ {/^ *$EFFECT {/p}" $1 | sed -r "s/( *).*/\1/")
              [ "$EFFECT" != "atmos" ] && sed -i "/^effects {/,/^}/ {/^$SPACES$EFFECT {/,/^$SPACES}/ s/^/#/g}" $1
            done;;
     *.xml) EFFECTS=$(sed -n "/^ *<postprocess>$/,/^ *<\/postprocess>$/ {/^ *<stream type=\"music\">$/,/^ *<\/stream>$/ {/<stream type=\"music\">/d; /<\/stream>/d; s/<apply effect=\"//g; s/\"\/>//g; p}}" $1)
            for EFFECT in ${EFFECTS}; do
              [ "$EFFECT" != "atmos" ] && sed -ri "s/^( *)<apply effect=\"$EFFECT\"\/>/\1<\!--<apply effect=\"$EFFECT\"\/>-->/" $1
            done;;
  esac
}

# Tell user aml is needed if applicable
if $MAGISK && ! $SYSOVERRIDE; then
  if $BOOTMODE; then LOC="/sbin/.core/img/*/system $MOUNTPATH/*/system"; else LOC="$MOUNTPATH/*/system"; fi
  FILES=$(find $LOC -type f -name "*audio_effects*.conf" -o -name "*audio_effects*.xml")
  if [ ! -z "$FILES" ] && [ ! "$(echo $FILES | grep '/aml/')" ]; then
    ui_print " "
    ui_print "   ! Conflicting audio mod found!"
    ui_print "   ! You will need to install !"
    ui_print "   ! Audio Modification Library !"
    sleep 3
  fi
fi

if $libsinstall || [ "$htc" ] || [ "$axon" ]; then
  mkdir -p $INSTALLER/system/lib $INSTALLER/system/lib64
  cp -f $INSTALLER/custom/lib/* $INSTALLER/system/lib
  cp -f $INSTALLER/custom/lib64/* $INSTALLER/system/lib64
else
  for FILE in "libradio.so" "libradioservice.so"; do
    if [ ! -f "/system/lib/$FILE" ]; then
      mkdir -p $INSTALLER/system/lib $INSTALLER/system/lib64
      cp -f $INSTALLER/custom/lib/$FILE $INSTALLER/system/lib/$FILE
      $IS64BIT && cp -f $INSTALLER/custom/lib64/$FILE $INSTALLER/system/lib64/$FILE
    fi
  done
fi

if [ "$(grep "android.hardware.broadcastradio" /system/vendor/manifest.xml)" ]; then
  ui_print " "
  ui_print "   ! Removing broadcastradio from vendor manifest !"
  ui_print "   ! May break some radio functions. You've been warned !"
  ui_print " "
  [ ! -f "/system/vendor/manifest.xml.bak" ] && { cp -f /system/vendor/manifest.xml /system/vendor/manifest.xml.bak; chcon u:object_r:vendor_configs_file:s0 /system/vendor/manifest.xml.bak; echo "/system/vendor/manifest.xml.bak" >> $INFO; }
  echo "/system/vendor/manifest.xml" >> $INFO
  MATCH=$(grep -n 'android.hardware.broadcastradio' /system/vendor/manifest.xml | cut -d: -f 1)
  sed -i "$(($MATCH - 1)),$(($MATCH + 7))d" /system/vendor/manifest.xml
fi

for OFILE in ${CFGS}; do
  FILE="$UNITY$(echo $OFILE | sed "s|^/vendor|/system/vendor|g")"
  cp_ch_nb $ORIGDIR$OFILE $FILE 0644 false
  osp_detect $FILE
  case $FILE in
    *.conf) if [ ! "$(grep "vlldp" $FILE)" ]; then
              sed -i "s/^libraries {/libraries {\n  vlldp { #$MODID\n    path \/vendor\/lib\/soundfx\/libswvlldp.so\n  } #$MODID/g" $FILE
              sed -i "s/^libraries {/libraries {\n  atmos { #$MODID\n    path \/vendor\/lib\/soundfx\/libatmos.so\n  } #$MODID/g" $FILE
              sed -i "s/^effects {/effects {\n  vlldp { #$MODID\n    library vlldp\n    uuid 3783c334-d3a0-4d13-874f-0032e5fb80e2\n  } #$MODID/g" $FILE
              sed -i "s/^effects {/effects {\n  atmos { #$MODID\n    library atmos\n    uuid 9d4921da-8225-4f29-aefa-aacb40a73593\n  } #$MODID/g" $FILE
            fi
            if [ ! "$(sed -n "/^output_session_processing {/,/^}/p" $FILE)" ]; then
              echo -e "output_session_processing {\n    music {\n        atmos {\n        }\n    }\n}" >> $FILE
            elif [ ! "$(sed -n "/^output_session_processing {/,/^}/ {/music {/,/^    }/p}" $FILE)" ]; then
              sed -i "/output_session_processing {/,/^}/ s/output_session_processing {/output_session_processing {\n    music {\n        atmos {\n        }\n    }/" $FILE
            elif [ ! "$(sed -n "/^output_session_processing {/,/^}/ {/music {/,/^    }/ {/atmos {/,/}/p}}" $FILE)" ]; then
              sed -i "/output_session_processing {/,/^}/ {/music {/,/^    }/ s/music {/music {\n        atmos {\n        }/}" $FILE
            fi;;
   *.xml) if [ ! "$(grep "vlldp" $FILE)" ]; then
            sed -i "/<libraries>/ a\        <library name=\"atmos\" path=\"libatmos.so\"\/><!--$MODID-->" $FILE
            sed -i "/<libraries>/ a\        <library name=\"vlldp\" path=\"libswvlldp.so\"\/><!--$MODID-->" $FILE
            sed -i "/<effects>/ a\        <effect name=\"vlldp\" library=\"vlldp\" uuid=\"3783c334-d3a0-4d13-874f-0032e5fb80e2\"\/><!--$MODID-->" $FILE
            sed -i "/<effects>/ a\        <effect name=\"atmos\" library=\"atmos\" uuid=\"9d4921da-8225-4f29-aefa-aacb40a73593\"\/><!--$MODID-->" $FILE
          fi
          if [ ! "$(sed -n "/<postprocess>/,/<\/postprocess>/p" $FILE)" ]; then     
            sed -i "/<\/audio_effects_conf>/i\    <postprocess>\n       <stream type=\"music\">\n            <apply effect=\"atmos\"\/>\n        <\/stream>\n    <\/postprocess>" $FILE
          elif [ ! "$(sed -n "/<postprocess>/,/<\/postprocess>/ {/<stream type=\"music\">/,/<\/stream>/p}" $FILE)" ]; then     
            sed -i "/<postprocess>/,/<\/postprocess>/ s/    <postprocess>/    <postprocess>\n        <stream type=\"music\">\n            <apply effect=\"atmos\"\/>\n        <\/stream>/" $FILE
          elif [ ! "$(sed -n "/<postprocess>/,/<\/postprocess>/ {/<stream type=\"music\">/,/<\/stream>/ {/^ *<apply effect=\"atmos\"\/>/p}}" $FILE )" ]; then
            sed -i "/<postprocess>/,/<\/postprocess>/ {/<stream type=\"music\">/,/<\/stream>/ s/<stream type=\"music\">/<stream type=\"music\">\n            <apply effect=\"atmos\"\/>/}" $FILE
          fi;;
  esac   
done
